# 파이썬 기초문법 학습을 위한 새로운 객관식 문제 10개

def python_quiz():
    questions = [
        {
            "question": "1. 파이썬에서 문자열을 대체하는 함수는 무엇인가요?",
            "choices": ["replace()", "sub()", "switch()", "change()"],
            "answer": "replace()",
            "example": "'hello world'.replace('world', 'Python') -> 'hello Python'"
        },
        {
            "question": "2. 파이썬에서 리스트를 정렬하여 새로운 리스트를 반환하는 함수는?",
            "choices": ["sorted()", "sort()", "arrange()", "organize()"],
            "answer": "sorted()",
            "example": "sorted([3, 1, 2]) -> [1, 2, 3]"
        },
        {
            "question": "3. 파이썬에서 문자열을 특정 문자로 나누는 함수는?",
            "choices": ["split()", "partition()", "divide()", "cut()"],
            "answer": "split()",
            "example": "'a,b,c'.split(',') -> ['a', 'b', 'c']"
        },
        {
            "question": "4. 파이썬에서 리스트의 마지막 요소를 제거하는 함수는?",
            "choices": ["pop()", "remove()", "delete()", "discard()"],
            "answer": "pop()",
            "example": "my_list = [1, 2, 3]; my_list.pop() -> 3, my_list -> [1, 2]"
        },
        {
            "question": "5. 파이썬에서 값을 거듭 제곱하는 연산자는?",
            "choices": ["**", "^", "pow()", "exp()"],
            "answer": "**",
            "example": "2 ** 3 -> 8"
        },
        {
            "question": "6. 파이썬에서 반복 가능한 객체의 길이를 반환하는 함수는?",
            "choices": ["len()", "size()", "count()", "length()"],
            "answer": "len()",
            "example": "len([1, 2, 3]) -> 3"
        },
        {
            "question": "7. 파이썬에서 조건이 거짓일 때 예외를 발생시키는 키워드는?",
            "choices": ["assert", "raise", "throw", "error"],
            "answer": "assert",
            "example": "assert 2 + 2 == 4, '계산 오류'"
        },
        {
            "question": "8. 파이썬에서 `range(5)`가 반환하는 것은?",
            "choices": ["0부터 4까지의 숫자", "1부터 5까지의 숫자", "리스트", "딕셔너리"],
            "answer": "0부터 4까지의 숫자",
            "example": "list(range(5)) -> [0, 1, 2, 3, 4]"
        },
        {
            "question": "9. 파이썬에서 리스트를 병합하는 올바른 방법은?",
            "choices": ["+ 연산자", "append()", "merge()", "join()"],
            "answer": "+ 연산자",
            "example": "[1, 2] + [3, 4] -> [1, 2, 3, 4]"
        },
        {
            "question": "10. 파이썬에서 for 반복문과 함께 값을 동시에 인덱스와 함께 얻는 함수는?",
            "choices": ["enumerate()", "index()", "range()", "zip()"],
            "answer": "enumerate()",
            "example": "for index, value in enumerate(['a', 'b', 'c']): print(index, value)"
        }
    ]

    score = 0

    print("파이썬 기초문법 객관식 퀴즈에 오신 것을 환영합니다!\n")
    for i, q in enumerate(questions, 1):
        print(f"문제 {i}: {q['question']}")
        for idx, choice in enumerate(q['choices'], 1):
            print(f"  {idx}. {choice}")

        user_input = input("정답 번호를 입력하세요: ").strip()

        try:
            if q['choices'][int(user_input) - 1] == q['answer']:
                print("정답입니다! 🎉")
                print(f"예시: {q['example']}")
                score += 1
            else:
                print("오답입니다.")
                print(f"정답은: {q['answer']}")
                print(f"예시: {q['example']}")
        except (IndexError, ValueError):
            print("유효하지 않은 입력입니다. 다음 문제로 넘어갑니다.")

        print("\n")

    print(f"총 점수: {score}/{len(questions)}")
    print("퀴즈가 끝났습니다. 파이썬 학습에 성공하세요! 🐍")

if __name__ == "__main__":
    python_quiz()
