# 파이썬 기초문법 학습을 위한 객관식 문제 10개

def python_quiz():
    questions = [
        {
            "question": "1. 변수에 값을 할당할 때 사용하는 연산자는 무엇인가요?",
            "choices": ["=", "==", "!=", "<", ">"],
            "answer": "=",
            "example": "x = 10"
        },
        {
            "question": "2. 리스트에서 첫 번째 요소에 접근하는 방법은 무엇인가요?",
            "choices": ["list[1]", "list[0]", "list.first()", "list.get(0)"],
            "answer": "list[0]",
            "example": "my_list = [1, 2, 3]; my_list[0] -> 1"
        },
        {
            "question": "3. 문자열의 모든 문자를 소문자로 변환하는 함수는?",
            "choices": ["lower()", "upper()", "capitalize()", "title()"],
            "answer": "lower()",
            "example": "'HELLO'.lower() -> 'hello'"
        },
        {
            "question": "4. 파이썬에서 반복문으로 리스트를 순회할 때 사용하는 키워드는?",
            "choices": ["for", "while", "do", "loop"],
            "answer": "for",
            "example": "for item in [1, 2, 3]: print(item)"
        },
        {
            "question": "5. 파이썬에서 조건문을 작성할 때 사용하는 키워드는?",
            "choices": ["if", "when", "switch", "case"],
            "answer": "if",
            "example": "if x > 0: print('Positive')"
        },
        {
            "question": "6. 딕셔너리에서 키에 해당하는 값을 가져오는 함수는?",
            "choices": ["get()", "fetch()", "retrieve()", "find()"],
            "answer": "get()",
            "example": "my_dict = {'key': 'value'}; my_dict.get('key') -> 'value'"
        },
        {
            "question": "7. 리스트에 요소를 추가하는 함수는?",
            "choices": ["append()", "add()", "insert()", "extend()"],
            "answer": "append()",
            "example": "my_list = [1, 2]; my_list.append(3) -> [1, 2, 3]"
        },
        {
            "question": "8. 숫자 3.5를 정수로 변환하는 함수는?",
            "choices": ["int()", "float()", "str()", "round()"],
            "answer": "int()",
            "example": "int(3.5) -> 3"
        },
        {
            "question": "9. 파이썬에서 주석을 작성할 때 사용하는 기호는?",
            "choices": ["#", "//", "/* */", "--"],
            "answer": "#",
            "example": "# This is a comment"
        },
        {
            "question": "10. 리스트의 길이를 반환하는 함수는?",
            "choices": ["len()", "size()", "count()", "length()"],
            "answer": "len()",
            "example": "len([1, 2, 3]) -> 3"
        }
    ]

    score = 0

    print("파이썬 기초문법 객관식 퀴즈에 오신 것을 환영합니다!\n")
    for i, q in enumerate(questions, 1):
        print(f"문제 {i}: {q['question']}")
        for idx, choice in enumerate(q['choices'], 1):
            print(f"  {idx}. {choice}")

        user_input = input("정답 번호를 입력하세요: ").strip()

        try:
            if q['choices'][int(user_input) - 1] == q['answer']:
                print("정답입니다! 🎉")
                print(f"예시: {q['example']}")
                score += 1
            else:
                print("오답입니다.")
                print(f"정답은: {q['answer']}")
                print(f"예시: {q['example']}")
        except (IndexError, ValueError):
            print("유효하지 않은 입력입니다. 다음 문제로 넘어갑니다.")

        print("\n")

    print(f"총 점수: {score}/{len(questions)}")
    print("퀴즈가 끝났습니다. 파이썬 학습에 성공하세요! 🐍")

if __name__ == "__main__":
    python_quiz()
