# 파이썬 기초문법 학습을 위한 새로운 객관식 문제 10개

def python_quiz():
    questions = [
        {
            "question": "1. 파이썬에서 숫자형 데이터 타입이 아닌 것은?",
            "choices": ["int", "float", "str", "complex"],
            "answer": "str",
            "example": "숫자형 데이터 타입은 int, float, complex입니다. str은 문자열 타입입니다."
        },
        {
            "question": "2. 리스트에 요소를 정렬하는 방법은 무엇인가요?",
            "choices": ["sort()", "order()", "arrange()", "sorted()"],
            "answer": "sort()",
            "example": "my_list = [3, 1, 2]; my_list.sort() -> [1, 2, 3]"
        },
        {
            "question": "3. 파이썬에서 무한 반복을 수행하는 반복문은?",
            "choices": ["for", "while", "do-while", "repeat"],
            "answer": "while",
            "example": "while True: print('무한 반복')"
        },
        {
            "question": "4. 파이썬에서 함수의 기본 값을 설정하는 방법은?",
            "choices": ["def func(x=10):", "def func(int x=10):", "def func(x):=10", "def func(x:int=10):"],
            "answer": "def func(x=10):",
            "example": "def greet(name='World'): print(f'Hello, {name}!')"
        },
        {
            "question": "5. 다음 중 파이썬에서 예외를 처리하는 키워드는 무엇인가요?",
            "choices": ["try", "except", "finally", "모두 해당"],
            "answer": "모두 해당",
            "example": "try: x = 1 / 0\nexcept ZeroDivisionError: print('에러 처리')\nfinally: print('완료')"
        },
        {
            "question": "6. 리스트를 복사할 때 사용하는 방법은?",
            "choices": ["copy()", "clone()", "replicate()", "duplicate()"],
            "answer": "copy()",
            "example": "my_list = [1, 2, 3]; new_list = my_list.copy()"
        },
        {
            "question": "7. 파이썬에서 현재 디렉토리를 확인하는 함수는?",
            "choices": ["os.getcwd()", "os.listdir()", "os.chdir()", "os.get()"],
            "answer": "os.getcwd()",
            "example": "import os; print(os.getcwd())"
        },
        {
            "question": "8. 문자열에서 공백을 제거하는 방법은?",
            "choices": ["strip()", "remove()", "trim()", "delete()"],
            "answer": "strip()",
            "example": "'  hello  '.strip() -> 'hello'"
        },
        {
            "question": "9. 다음 중 파이썬에서 변수를 삭제하는 키워드는?",
            "choices": ["del", "remove", "delete", "clear"],
            "answer": "del",
            "example": "x = 10; del x"
        },
        {
            "question": "10. 문자열에서 특정 문자를 대체하는 함수는?",
            "choices": ["replace()", "substitute()", "change()", "modify()"],
            "answer": "replace()",
            "example": "'hello world'.replace('world', 'Python') -> 'hello Python'"
        }
    ]

    score = 0

    print("파이썬 기초문법 객관식 퀴즈에 오신 것을 환영합니다!\n")
    for i, q in enumerate(questions, 1):
        print(f"문제 {i}: {q['question']}")
        for idx, choice in enumerate(q['choices'], 1):
            print(f"  {idx}. {choice}")

        user_input = input("정답 번호를 입력하세요: ").strip()

        try:
            if q['choices'][int(user_input) - 1] == q['answer']:
                print("정답입니다! 🎉")
                print(f"예시: {q['example']}")
                score += 1
            else:
                print("오답입니다.")
                print(f"정답은: {q['answer']}")
                print(f"예시: {q['example']}")
        except (IndexError, ValueError):
            print("유효하지 않은 입력입니다. 다음 문제로 넘어갑니다.")

        print("\n")

    print(f"총 점수: {score}/{len(questions)}")
    print("퀴즈가 끝났습니다. 파이썬 학습에 성공하세요! 🐍")

if __name__ == "__main__":
    python_quiz()
