# 파이썬 기초문법 학습을 위한 새로운 객관식 문제 10개

def python_quiz():
    questions = [
        {
            "question": "1. 파이썬에서 주어진 리스트에서 가장 작은 값을 반환하는 함수는 무엇인가요?",
            "choices": ["min()", "max()", "reduce()", "sorted()"],
            "answer": "min()",
            "example": "my_list = [3, 1, 2]; min(my_list) -> 1"
        },
        {
            "question": "2. 파이썬에서 반복 가능한 객체를 순회하며 처리하는 함수는?",
            "choices": ["map()", "filter()", "reduce()", "all()"],
            "answer": "map()",
            "example": "list(map(lambda x: x * 2, [1, 2, 3])) -> [2, 4, 6]"
        },
        {
            "question": "3. 문자열에서 모든 단어의 첫 글자를 대문자로 변환하는 함수는?",
            "choices": ["title()", "capitalize()", "upper()", "lower()"],
            "answer": "title()",
            "example": "'hello world'.title() -> 'Hello World'"
        },
        {
            "question": "4. 리스트를 뒤집는 함수는 무엇인가요?",
            "choices": ["reverse()", "reversed()", "flip()", "invert()"],
            "answer": "reverse()",
            "example": "my_list = [1, 2, 3]; my_list.reverse() -> [3, 2, 1]"
        },
        {
            "question": "5. 딕셔너리에서 키와 값을 튜플로 반환하는 함수는?",
            "choices": ["items()", "keys()", "values()", "pairs()"],
            "answer": "items()",
            "example": "my_dict = {'a': 1, 'b': 2}; my_dict.items() -> dict_items([('a', 1), ('b', 2)])"
        },
        {
            "question": "6. 튜플을 리스트로 변환하는 함수는?",
            "choices": ["list()", "tuple()", "convert()", "to_list()"],
            "answer": "list()",
            "example": "tuple_data = (1, 2, 3); list(tuple_data) -> [1, 2, 3]"
        },
        {
            "question": "7. 파이썬에서 함수를 호출할 때 키워드 인자를 사용하는 방법은?",
            "choices": ["func(name='John')", "func('John')", "func->name='John'", "func::name='John'"],
            "answer": "func(name='John')",
            "example": "def greet(name): print(f'Hello, {name}!'); greet(name='John') -> 'Hello, John!'"
        },
        {
            "question": "8. 문자열을 특정 구분자로 나누는 함수는?",
            "choices": ["split()", "join()", "partition()", "divide()"],
            "answer": "split()",
            "example": "'a,b,c'.split(',') -> ['a', 'b', 'c']"
        },
        {
            "question": "9. 파이썬에서 값을 거듭 제곱하는 연산자는?",
            "choices": ["**", "*", "^", "pow()"],
            "answer": "**",
            "example": "2 ** 3 -> 8"
        },
        {
            "question": "10. 리스트에서 요소를 제거하는 함수는?",
            "choices": ["remove()", "delete()", "pop()", "clear()"],
            "answer": "remove()",
            "example": "my_list = [1, 2, 3]; my_list.remove(2) -> [1, 3]"
        }
    ]

    score = 0

    print("파이썬 기초문법 객관식 퀴즈에 오신 것을 환영합니다!\n")
    for i, q in enumerate(questions, 1):
        print(f"문제 {i}: {q['question']}")
        for idx, choice in enumerate(q['choices'], 1):
            print(f"  {idx}. {choice}")

        user_input = input("정답 번호를 입력하세요: ").strip()

        try:
            if q['choices'][int(user_input) - 1] == q['answer']:
                print("정답입니다! 🎉")
                print(f"예시: {q['example']}")
                score += 1
            else:
                print("오답입니다.")
                print(f"정답은: {q['answer']}")
                print(f"예시: {q['example']}")
        except (IndexError, ValueError):
            print("유효하지 않은 입력입니다. 다음 문제로 넘어갑니다.")

        print("\n")

    print(f"총 점수: {score}/{len(questions)}")
    print("퀴즈가 끝났습니다. 파이썬 학습에 성공하세요! 🐍")

if __name__ == "__main__":
    python_quiz()
