# 파이썬 기초문법 학습을 위한 새로운 객관식 문제 10개

def python_quiz():
    questions = [
        {
            "question": "1. 파이썬에서 사용되지 않는 논리 연산자는 무엇인가요?",
            "choices": ["and", "or", "xor", "not"],
            "answer": "xor",
            "example": "파이썬에서는 xor 대신 비트 연산자 ^를 사용합니다."
        },
        {
            "question": "2. 리스트에 여러 요소를 한 번에 추가할 때 사용하는 함수는?",
            "choices": ["append()", "extend()", "insert()", "add()"],
            "answer": "extend()",
            "example": "my_list = [1, 2]; my_list.extend([3, 4]) -> [1, 2, 3, 4]"
        },
        {
            "question": "3. 함수에서 여러 값을 반환하려면 어떤 자료형을 주로 사용하나요?",
            "choices": ["리스트", "튜플", "딕셔너리", "집합"],
            "answer": "튜플",
            "example": "def get_values(): return 1, 2; x, y = get_values()"
        },
        {
            "question": "4. 파이썬에서 파일을 열 때 사용하는 기본 모드는 무엇인가요?",
            "choices": ["w", "r", "a", "x"],
            "answer": "r",
            "example": "open('file.txt', 'r') -> 파일을 읽기 모드로 엽니다."
        },
        {
            "question": "5. 파이썬에서 문자열의 공백을 제거하는 함수는?",
            "choices": ["strip()", "remove()", "delete()", "pop()"],
            "answer": "strip()",
            "example": "'  hello  '.strip() -> 'hello'"
        },
        {
            "question": "6. 딕셔너리에 새 키-값 쌍을 추가하는 올바른 방법은?",
            "choices": ["dict.add(key, value)", "dict[key] = value", "dict.update([key, value])", "dict.insert(key, value)"],
            "answer": "dict[key] = value",
            "example": "my_dict = {}; my_dict['name'] = 'Alice'"
        },
        {
            "question": "7. 파이썬에서 반복문을 즉시 종료하는 키워드는?",
            "choices": ["stop", "break", "continue", "exit"],
            "answer": "break",
            "example": "for x in range(5):\n    if x == 3:\n        break\n    print(x)"
        },
        {
            "question": "8. 리스트를 오름차순으로 정렬하는 함수는?",
            "choices": ["sort()", "sorted()", "order()", "arrange()"],
            "answer": "sort()",
            "example": "my_list = [3, 1, 2]; my_list.sort() -> [1, 2, 3]"
        },
        {
            "question": "9. 파이썬에서 조건이 참인 경우 실행되는 코드는?",
            "choices": ["if", "when", "case", "switch"],
            "answer": "if",
            "example": "if x > 0: print('Positive')"
        },
        {
            "question": "10. 숫자를 반올림하는 함수는 무엇인가요?",
            "choices": ["round()", "ceil()", "floor()", "truncate()"],
            "answer": "round()",
            "example": "round(3.5) -> 4"
        }
    ]

    score = 0

    print("파이썬 기초문법 객관식 퀴즈에 오신 것을 환영합니다!\n")
    for i, q in enumerate(questions, 1):
        print(f"문제 {i}: {q['question']}")
        for idx, choice in enumerate(q['choices'], 1):
            print(f"  {idx}. {choice}")

        user_input = input("정답 번호를 입력하세요: ").strip()

        try:
            if q['choices'][int(user_input) - 1] == q['answer']:
                print("정답입니다! 🎉")
                print(f"예시: {q['example']}")
                score += 1
            else:
                print("오답입니다.")
                print(f"정답은: {q['answer']}")
                print(f"예시: {q['example']}")
        except (IndexError, ValueError):
            print("유효하지 않은 입력입니다. 다음 문제로 넘어갑니다.")

        print("\n")

    print(f"총 점수: {score}/{len(questions)}")
    print("퀴즈가 끝났습니다. 파이썬 학습에 성공하세요! 🐍")

if __name__ == "__main__":
    python_quiz()
