# 파이썬 기초문법 학습을 위한 새로운 객관식 문제 10개

def python_quiz():
    questions = [
        {
            "question": "1. 파이썬에서 세미콜론(;)의 역할은 무엇인가요?",
            "choices": [
                "한 줄에 여러 명령어를 구분",
                "문장을 종료",
                "코드를 주석으로 만듦",
                "아무 역할도 하지 않음"
            ],
            "answer": "한 줄에 여러 명령어를 구분",
            "example": "print('Hello'); print('World')"
        },
        {
            "question": "2. 파이썬에서 전역 변수를 함수 안에서 수정하려면 어떤 키워드를 사용해야 하나요?",
            "choices": ["global", "local", "nonlocal", "const"],
            "answer": "global",
            "example": "global x; x = 5"
        },
        {
            "question": "3. 다음 중 파이썬에서 값을 비교하는 연산자는?",
            "choices": ["==", "=", "!=", "모두 해당"],
            "answer": "모두 해당",
            "example": "x == y, x != y"
        },
        {
            "question": "4. 리스트의 모든 요소에 대해 특정 작업을 적용한 결과를 반환하는 함수는?",
            "choices": ["map()", "filter()", "reduce()", "zip()"],
            "answer": "map()",
            "example": "list(map(lambda x: x * 2, [1, 2, 3])) -> [2, 4, 6]"
        },
        {
            "question": "5. 파이썬에서 객체의 타입을 확인하는 함수는?",
            "choices": ["type()", "id()", "isinstance()", "dir()"],
            "answer": "type()",
            "example": "type(10) -> <class 'int'>"
        },
        {
            "question": "6. 리스트에서 중복 요소를 제거하려면 어떤 자료형을 사용하나요?",
            "choices": ["set", "dict", "tuple", "list"],
            "answer": "set",
            "example": "list(set([1, 2, 2, 3])) -> [1, 2, 3]"
        },
        {
            "question": "7. 파이썬에서 비어 있는 값을 나타내는 키워드는?",
            "choices": ["None", "Null", "Empty", "Void"],
            "answer": "None",
            "example": "x = None"
        },
        {
            "question": "8. 다음 중 반복 가능한 객체를 생성하지 않는 것은?",
            "choices": ["range()", "enumerate()", "zip()", "break()"],
            "answer": "break()",
            "example": "break는 반복문을 종료하는 키워드입니다."
        },
        {
            "question": "9. 파이썬에서 False로 간주되지 않는 값은?",
            "choices": [
                "0",
                "빈 문자열('')",
                "빈 리스트([])",
                "1"
            ],
            "answer": "1",
            "example": "bool(1) -> True"
        },
        {
            "question": "10. 파이썬에서 반복문과 함께 사용하여 조건을 만족하는 경우만 실행되는 키워드는?",
            "choices": ["continue", "break", "pass", "return"],
            "answer": "continue",
            "example": "for x in range(5): if x % 2 == 0: continue; print(x)"
        }
    ]

    score = 0

    print("파이썬 기초문법 객관식 퀴즈에 오신 것을 환영합니다!\n")
    for i, q in enumerate(questions, 1):
        print(f"문제 {i}: {q['question']}")
        for idx, choice in enumerate(q['choices'], 1):
            print(f"  {idx}. {choice}")

        user_input = input("정답 번호를 입력하세요: ").strip()

        try:
            if q['choices'][int(user_input) - 1] == q['answer']:
                print("정답입니다! 🎉")
                print(f"예시: {q['example']}")
                score += 1
            else:
                print("오답입니다.")
                print(f"정답은: {q['answer']}")
                print(f"예시: {q['example']}")
        except (IndexError, ValueError):
            print("유효하지 않은 입력입니다. 다음 문제로 넘어갑니다.")

        print("\n")

    print(f"총 점수: {score}/{len(questions)}")
    print("퀴즈가 끝났습니다. 파이썬 학습에 성공하세요! 🐍")

if __name__ == "__main__":
    python_quiz()
