# 파이썬 기초문법 학습을 위한 새로운 객관식 문제 10개

def python_quiz():
    questions = [
        {
            "question": "1. 파이썬에서 리스트와 튜플의 주요 차이점은 무엇인가요?",
            "choices": [
                "튜플은 변경할 수 없고, 리스트는 변경 가능하다.",
                "리스트는 불변하고, 튜플은 변경 가능하다.",
                "튜플은 항상 정렬되어 있다.",
                "리스트는 딕셔너리의 키로 사용된다."
            ],
            "answer": "튜플은 변경할 수 없고, 리스트는 변경 가능하다.",
            "example": "my_list = [1, 2, 3]; my_list[0] = 10\nmy_tuple = (1, 2, 3); my_tuple[0] = 10 # Error"
        },
        {
            "question": "2. 파이썬에서 슬라이싱을 사용하여 리스트의 일부를 추출하는 방법은?",
            "choices": [
                "list[start:end]",
                "list[start->end]",
                "list(start:end)",
                "list[start to end]"
            ],
            "answer": "list[start:end]",
            "example": "my_list = [0, 1, 2, 3, 4]; my_list[1:4] -> [1, 2, 3]"
        },
        {
            "question": "3. 파이썬에서 리스트의 모든 요소를 합산하는 함수는?",
            "choices": ["sum()", "total()", "add()", "combine()"],
            "answer": "sum()",
            "example": "sum([1, 2, 3]) -> 6"
        },
        {
            "question": "4. 파이썬에서 None의 역할은 무엇인가요?",
            "choices": [
                "변수를 초기화하지 않은 상태를 나타냄",
                "오류 메시지를 나타냄",
                "무한 루프를 종료시킴",
                "값이 비어있음을 나타냄"
            ],
            "answer": "값이 비어있음을 나타냄",
            "example": "x = None; print(x) # 출력: None"
        },
        {
            "question": "5. 파이썬에서 딕셔너리의 모든 키를 가져오는 함수는?",
            "choices": ["keys()", "values()", "items()", "get()"],
            "answer": "keys()",
            "example": "my_dict = {'a': 1, 'b': 2}; my_dict.keys() -> dict_keys(['a', 'b'])"
        },
        {
            "question": "6. 파이썬에서 반복문을 중첩하여 사용하는 방법은?",
            "choices": [
                "for i in range(3): for j in range(2): ...",
                "while i in range(3): while j in range(2): ...",
                "loop i in range(3): loop j in range(2): ...",
                "nested for i in range(3), j in range(2): ..."
            ],
            "answer": "for i in range(3): for j in range(2): ...",
            "example": "for i in range(3):\n    for j in range(2):\n        print(i, j)"
        },
        {
            "question": "7. 파이썬에서 람다 함수의 특징은 무엇인가요?",
            "choices": [
                "이름 없는 익명 함수",
                "반드시 이름이 있어야 함",
                "한 줄로만 작성 가능",
                "이름 없는 익명 함수, 한 줄로만 작성 가능"
            ],
            "answer": "이름 없는 익명 함수, 한 줄로만 작성 가능",
            "example": "f = lambda x: x + 1; f(2) -> 3"
        },
        {
            "question": "8. 파이썬에서 리스트 요소를 역순으로 정렬하는 방법은?",
            "choices": [
                "list.reverse()",
                "reverse(list)",
                "sorted(list, reverse=True)",
                "모두 가능"
            ],
            "answer": "모두 가능",
            "example": "my_list = [3, 1, 2]; my_list.reverse() -> [2, 1, 3]"
        },
        {
            "question": "9. 파이썬에서 조건문과 반복문을 한 줄로 작성할 수 있는 기능은?",
            "choices": ["리스트 컴프리헨션", "조건문 함수", "반복문 조합", "조건식 반복"],
            "answer": "리스트 컴프리헨션",
            "example": "[x for x in range(5) if x % 2 == 0] -> [0, 2, 4]"
        },
        {
            "question": "10. 파이썬에서 예외를 발생시키는 키워드는?",
            "choices": ["raise", "try", "except", "throw"],
            "answer": "raise",
            "example": "raise ValueError('Invalid value')"
        }
    ]

    score = 0

    print("파이썬 기초문법 객관식 퀴즈에 오신 것을 환영합니다!\n")
    for i, q in enumerate(questions, 1):
        print(f"문제 {i}: {q['question']}")
        for idx, choice in enumerate(q['choices'], 1):
            print(f"  {idx}. {choice}")

        user_input = input("정답 번호를 입력하세요: ").strip()

        try:
            if q['choices'][int(user_input) - 1] == q['answer']:
                print("정답입니다! 🎉")
                print(f"예시: {q['example']}")
                score += 1
            else:
                print("오답입니다.")
                print(f"정답은: {q['answer']}")
                print(f"예시: {q['example']}")
        except (IndexError, ValueError):
            print("유효하지 않은 입력입니다. 다음 문제로 넘어갑니다.")

        print("\n")

    print(f"총 점수: {score}/{len(questions)}")
    print("퀴즈가 끝났습니다. 파이썬 학습에 성공하세요! 🐍")

if __name__ == "__main__":
    python_quiz()
