# 파이썬 기초문법 학습을 위한 새로운 객관식 문제 10개

def python_quiz():
    questions = [
        {
            "question": "1. 파이썬에서 기본적으로 제공하는 정렬 함수는?",
            "choices": ["sorted()", "order()", "arrange()", "sort()"],
            "answer": "sorted()",
            "example": "sorted([3, 1, 2]) -> [1, 2, 3]"
        },
        {
            "question": "2. 파이썬에서 불 자료형의 값이 아닌 것은?",
            "choices": ["True", "False", "1", "None"],
            "answer": "None",
            "example": "불 자료형은 True 또는 False로만 구성됩니다."
        },
        {
            "question": "3. 파이썬에서 임의의 요소를 선택하는 함수는 무엇인가요?",
            "choices": ["random.choice()", "random.pick()", "random.select()", "random.item()"],
            "answer": "random.choice()",
            "example": "import random; random.choice([1, 2, 3])"
        },
        {
            "question": "4. 파이썬에서 현재 시간을 가져오는 모듈은 무엇인가요?",
            "choices": ["datetime", "time", "date", "os"],
            "answer": "datetime",
            "example": "from datetime import datetime; print(datetime.now())"
        },
        {
            "question": "5. 파이썬에서 객체의 속성과 메서드를 나열하는 함수는?",
            "choices": ["dir()", "list()", "help()", "dict()"],
            "answer": "dir()",
            "example": "dir(object)"
        },
        {
            "question": "6. 파이썬에서 파일을 쓰기 모드로 여는 기본 명령은?",
            "choices": ["open('file.txt', 'w')", "write('file.txt')", "file('file.txt', 'w')", "open('file.txt', 'write')"],
            "answer": "open('file.txt', 'w')",
            "example": "with open('file.txt', 'w') as f: f.write('Hello')"
        },
        {
            "question": "7. 파이썬에서 무작위로 정수를 생성하는 함수는?",
            "choices": ["random.randint()", "random.random()", "random.int()", "random.range()"],
            "answer": "random.randint()",
            "example": "import random; random.randint(1, 10)"
        },
        {
            "question": "8. 파이썬에서 조건문을 여러 개 사용하는 키워드는?",
            "choices": ["elif", "else if", "elseif", "else"],
            "answer": "elif",
            "example": "if x > 10: pass elif x > 5: pass"
        },
        {
            "question": "9. 파이썬에서 빈 리스트를 생성하는 올바른 방법은?",
            "choices": ["[]", "list()", "both", "None"],
            "answer": "both",
            "example": "my_list = []; my_list = list()"
        },
        {
            "question": "10. 파이썬에서 파일을 읽기 모드로 여는 기본 명령은?",
            "choices": ["open('file.txt', 'r')", "file('file.txt', 'r')", "read('file.txt')", "open('file.txt')"],
            "answer": "open('file.txt', 'r')",
            "example": "with open('file.txt', 'r') as f: print(f.read())"
        }
    ]

    score = 0

    print("파이썬 기초문법 객관식 퀴즈에 오신 것을 환영합니다!\n")
    for i, q in enumerate(questions, 1):
        print(f"문제 {i}: {q['question']}")
        for idx, choice in enumerate(q['choices'], 1):
            print(f"  {idx}. {choice}")

        user_input = input("정답 번호를 입력하세요: ").strip()

        try:
            if q['choices'][int(user_input) - 1] == q['answer']:
                print("정답입니다! 🎉")
                print(f"예시: {q['example']}")
                score += 1
            else:
                print("오답입니다.")
                print(f"정답은: {q['answer']}")
                print(f"예시: {q['example']}")
        except (IndexError, ValueError):
            print("유효하지 않은 입력입니다. 다음 문제로 넘어갑니다.")

        print("\n")

    print(f"총 점수: {score}/{len(questions)}")
    print("퀴즈가 끝났습니다. 파이썬 학습에 성공하세요! 🐍")

if __name__ == "__main__":
    python_quiz()
