# 파이썬 기초문법 학습을 위한 새로운 객관식 문제 10개

def python_quiz():
    questions = [
        {
            "question": "1. 파이썬에서 딕셔너리에서 키가 존재하는지 확인하는 연산자는?",
            "choices": ["in", "exists", "has", "key"],
            "answer": "in",
            "example": "my_dict = {'a': 1}; 'a' in my_dict -> True"
        },
        {
            "question": "2. 파이썬에서 값을 나누고 소수점 이하를 버리는 연산자는?",
            "choices": ["//", "/", "%", "div"],
            "answer": "//",
            "example": "10 // 3 -> 3"
        },
        {
            "question": "3. 파이썬에서 집합(set)의 중복 제거 기능을 설명하는 올바른 것은?",
            "choices": [
                "중복된 값을 제거한다.",
                "값을 정렬한다.",
                "값을 키로 변환한다.",
                "값을 인덱스로 변환한다."
            ],
            "answer": "중복된 값을 제거한다.",
            "example": "set([1, 2, 2, 3]) -> {1, 2, 3}"
        },
        {
            "question": "4. 파이썬에서 반복문을 사용하여 문자열을 순회할 때 사용하는 기본 구조는?",
            "choices": ["for", "while", "do-while", "loop"],
            "answer": "for",
            "example": "for char in 'hello': print(char)"
        },
        {
            "question": "5. 파이썬에서 함수의 기본값을 설정하려면?",
            "choices": ["def func(x=10):", "def func(x==10):", "def func(int x=10):", "def func(x):=10"],
            "answer": "def func(x=10):",
            "example": "def greet(name='World'): print(f'Hello, {name}!')"
        },
        {
            "question": "6. 파이썬에서 여러 줄 문자열을 작성할 때 사용하는 기호는?",
            "choices": ["''' 또는 \"\"\"", "''", "\"", "//"],
            "answer": "''' 또는 \"\"\"",
            "example": "'''This is a\nmulti-line string'''"
        },
        {
            "question": "7. 파이썬에서 리스트에 요소를 추가하는 함수는?",
            "choices": ["append()", "add()", "insert()", "push()"],
            "answer": "append()",
            "example": "my_list = [1, 2]; my_list.append(3) -> [1, 2, 3]"
        },
        {
            "question": "8. 파이썬에서 클래스의 메서드가 첫 번째 매개변수로 self를 사용하는 이유는?",
            "choices": [
                "인스턴스 자신을 참조하기 위해",
                "클래스 변수를 선언하기 위해",
                "상속을 구현하기 위해",
                "오류를 방지하기 위해"
            ],
            "answer": "인스턴스 자신을 참조하기 위해",
            "example": "class MyClass: def method(self): pass"
        },
        {
            "question": "9. 파이썬에서 문자를 아스키 코드로 변환하는 함수는?",
            "choices": ["ord()", "chr()", "ascii()", "code()"],
            "answer": "ord()",
            "example": "ord('A') -> 65"
        },
        {
            "question": "10. 파이썬에서 한 줄 주석을 작성할 때 사용하는 기호는?",
            "choices": ["#", "//", "<!--", "**"],
            "answer": "#",
            "example": "# This is a comment"
        }
    ]

    score = 0

    print("파이썬 기초문법 객관식 퀴즈에 오신 것을 환영합니다!\n")
    for i, q in enumerate(questions, 1):
        print(f"문제 {i}: {q['question']}")
        for idx, choice in enumerate(q['choices'], 1):
            print(f"  {idx}. {choice}")

        user_input = input("정답 번호를 입력하세요: ").strip()

        try:
            if q['choices'][int(user_input) - 1] == q['answer']:
                print("정답입니다! 🎉")
                print(f"예시: {q['example']}")
                score += 1
            else:
                print("오답입니다.")
                print(f"정답은: {q['answer']}")
                print(f"예시: {q['example']}")
        except (IndexError, ValueError):
            print("유효하지 않은 입력입니다. 다음 문제로 넘어갑니다.")

        print("\n")

    print(f"총 점수: {score}/{len(questions)}")
    print("퀴즈가 끝났습니다. 파이썬 학습에 성공하세요! 🐍")

if __name__ == "__main__":
    python_quiz()
